## debcraft 0.1.1

=== Makefile ===
#!/usr/bin/make -f
# SPDX-FileCopyrightText: 2024 Otto Kekäläinen <otto@debian.org>
#
# SPDX-License-Identifier: GPL-3.0-or-later

# Ensure errors are emitted past the pipes to tee
SHELL=/bin/bash -o pipefail

DESTDIR:=tmp

all: build install

build-depends:
	@echo "Check all build dependencies are present"
	@echo -n "Codespell version: "
	@codespell --version
	@echo $$(shellcheck --version | head -n 2)
	@help2man --version | head -n 1

build: manpage build-depends

# @TODO: Use '--include manpage-extras' to include additional info or write the
# README.md as ronn or Pandoc compatible Markdown and convert README.md to man
# page instead of --help (and the --help instead could run 'man --pager=cat
# debcraft'). See
# https://manpages.ubuntu.com/manpages/noble/en/man7/ronn-format.7.html and
# https://eddieantonio.ca/blog/2015/12/18/authoring-manpages-in-markdown-with-pandoc/
manpage:
	@echo "Generate man page for Debcraft"
	mkdir --verbose --parents $(DESTDIR)/usr/share/man/man1
	help2man \
		--name "Debcraft" \
		--source "Debcraft" \
		--section 1 \
		--manual "Debcraft usage" \
		--output $(DESTDIR)/usr/share/man/man1/debcraft.1 \
		--no-info \
		./debcraft.sh
	# Filter out inclusion of DEB_BUILD_OPTIONS in static Makefile.
	sed -i -e 's@ (currently DEB_BUILD_OPTIONS=.*)\.@.@g' \
		$(DESTDIR)/usr/share/man/man1/debcraft.1

install: build
	install -v -p -D debcraft.sh $(DESTDIR)/usr/bin/debcraft
	# install -v -p -D --target-directory=$(DESTDIR)/usr/share/debcraft src/*
	# GNU 'install' does not support subdirectories, so use regular 'cp' instead
	cp -a src $(DESTDIR)/usr/share/debcraft

install-local:
	@echo "Installing Debcraft as symlinc at ~/bin/debcraft"
	ln --force --symbolic --verbose ${PWD}/debcraft.sh ~/bin/debcraft

test: test-static test-debcraft

# All generic static tests that don't need Debcraft to actually run
# @TODO: Evaluate using '-o all' to run extra validation (https://github.com/koalaman/shellcheck/wiki/Optional)
# @TODO: podman build --validate Containerfile?
test-static:
	@echo "Running static tests"
	codespell --interactive=0 --check-filenames --check-hidden --skip=.git
	shellcheck -x --shell=bash $(shell grep -Irnw -e '^#!.*/bash' | sort -u |cut -d ':' -f 1 | xargs)

# Run Debcraft and ensure it behaves as expected
test-debcraft:
	@echo "Running Debcraft tests"
	tests/debcraft-tests.sh

=== debian/changelog ===
debcraft (0.1.1) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * Update Vcs-* after project moved to general Debian namespace on Salsa
  * Handle missing signature files on pristine-tar branch properly
  * Install Debcraft library files in /usr/share/debcraft (Closes: #1077259)
  * Implement minimal and superficial autopkgtests for Debcraft
  * Use Debputy to lint and reformat (replacing wrap-and-sort)
  * See git commit log for full list of changes and explanations

  [ Chris Lamb ]
  * Omit run-time DEB_BUILD_OPTIONS contents from man page (Closes: 1077479)

  [ Bastian Venthur ]
  * Fix some more user facing spelling and improve README

 -- Otto Kekäläinen <otto@debian.org>  Mon, 29 Jul 2024 22:05:33 -0700

debcraft (0.1.0) unstable; urgency=medium

  * Initial release to Debian

 -- Otto Kekäläinen <otto@debian.org>  Mon, 01 Jul 2024 17:23:06 -0700

=== debian/tests/control ===
Tests: smoke
Depends: debcraft
Restrictions: superficial

## debcraft 0.2.0

=== debian/changelog ===
debcraft (0.2.0) unstable; urgency=medium

  * Resolve Debcraft version at run-time (Closes: #1077627)
  * Make 'oracular' the default Ubuntu branch
  * Make downloading and building in one go more robust
  * Make newly built packages available when running 'shell'
  * Add 'debcraft test' to run autopkgtest
  * Download package only on 'build' and 'validate', otherwise expect it
  * Compare to previous tagged release or build
  * Create buildinfo.log and changes.log with normalized names for diffing
  * Include string 'DEBCRAFT' in error messages

 -- Otto Kekäläinen <otto@debian.org>  Wed, 21 Aug 2024 15:28:01 -0700

## debcraft 0.2.1

=== Makefile ===
--- 
+++ 
@@ -29,8 +29,7 @@
 	@echo "Generate man page for Debcraft"
 	mkdir --verbose --parents $(DESTDIR)/usr/share/man/man1
 	help2man \
-		--name "Debcraft" \
-		--source "Debcraft" \
+		--name "Easy, fast and secure way to build Debian packages" \
 		--section 1 \
 		--manual "Debcraft usage" \
 		--output $(DESTDIR)/usr/share/man/man1/debcraft.1 \

=== debian/changelog ===
debcraft (0.2.1) unstable; urgency=medium

  * Improve man page
  * Refactor Containerfile to be compatible with older Debian releases
  * Bugfix: Use colon instead of 'pass', there is no such command in Bash

 -- Otto Kekäläinen <otto@debian.org>  Fri, 06 Sep 2024 18:40:31 -0700

## debcraft 0.3.0

=== debian/changelog ===
debcraft (0.3.0) unstable; urgency=medium

  * Always run `apt-get update` before installing packages in containers
  * Add 'plucky' as the new default Ubuntu development release
  * Export pristine-tar based on upstream version, not newness
  * Sort blhc.log to make comparisons between build practical
  * Refactor Containerfile to be available for even older Debian releases
  * Add support for building on Debian Stretch
  * Install command-not-found along with other validator dependencies
  * Skip log creation and analysis for .deb files when they don't exists
  * Activate extra repositories if `debian/ci/` exits
  * Add new option '--with-binaries' so releaser can be used to upload NEW packages

 -- Otto Kekäläinen <otto@debian.org>  Fri, 06 Dec 2024 18:36:59 -0800

## debcraft 0.4.0

=== Makefile ===
--- 
+++ 
@@ -41,13 +41,15 @@
 
 install: build
 	install -v -p -D debcraft.sh $(DESTDIR)/usr/bin/debcraft
+	install -v -p -D --mode=0644 bash-completion/debcraft-completion.sh $(DESTDIR)/usr/share/bash-completion/completions/debcraft
 	# install -v -p -D --target-directory=$(DESTDIR)/usr/share/debcraft src/*
 	# GNU 'install' does not support subdirectories, so use regular 'cp' instead
 	cp -a src $(DESTDIR)/usr/share/debcraft
 
 install-local:
 	@echo "Installing Debcraft as symlinc at ~/bin/debcraft"
-	ln --force --symbolic --verbose ${PWD}/debcraft.sh ~/bin/debcraft
+	ln --force --symbolic --verbose ${PWD}/debcraft.sh ~/.local/bin/debcraft
+	ln --force --symbolic --verbose ${PWD}/bash-completion/debcraft-completion.sh ~/.local/share/bash-completion/completions/debcraft
 
 test: test-static test-debcraft

=== debian/changelog ===
debcraft (0.4.0) unstable; urgency=medium

  * Implement proper Bash completion
  * Check that logs exist before trying to compare them
  * Ensure downloader has fresh apt archive cache available
  * Include ccache in 'debcraft release --with-binaries'
  * Introduce `debcraft build --skip-sources` and build full packages by default
  * Warn about potential unapplied patches on binary-only 'build' and 'test'

 -- Otto Kekäläinen <otto@debian.org>  Fri, 21 Feb 2025 21:10:40 -0800

=== debian/control ===
Source: debcraft
Section: misc
Priority: optional
Maintainer: Otto Kekäläinen <otto@debian.org>
Build-Depends:
 codespell <!nocheck>,
 debhelper-compat (= 13),
 git-buildpackage <!nocheck>,
 help2man,
 podman | docker.io  <!nocheck>,
 shellcheck <!nocheck>,
Standards-Version: 4.7.0
Homepage: https://salsa.debian.org/debian/debcraft
Rules-Requires-Root: no
Vcs-Git: https://salsa.debian.org/debian/debcraft.git
Vcs-Browser: https://salsa.debian.org/debian/debcraft

Package: debcraft
Architecture: all
Depends:
 podman | docker.io,
 ${misc:Depends},
Description: Easy, fast and secure way to build Debian packages
 Debcraft is a tool to build Debian packages as easily as possible. It uses
 Podman/Docker to automatically create a hermetic network-less build container
 based on the distribution defined in the source package debian/changelog with
 the dependencies defined in debian/control. Users don't need to manually create
 nor update root filesystems. If there is no source package, Debcraft will even
 automatically download it.
 .
 Thanks to efficient caching rebuilds are blazing fast, and additional logs make
 it easy to see what changed in the end result between each build.
 .
 The tool is fully written in Bash, so reasoning about how it works is easy. It
 does not even need to run on Debian as all builds happen inside containers.

## debcraft 0.5.0

=== Makefile ===
--- 
+++ 
@@ -48,6 +48,8 @@
 
 install-local:
 	@echo "Installing Debcraft as symlinc at ~/bin/debcraft"
+	mkdir -p ~/.local/bin
+	mkdir -p ~/.local/share/bash-completion/completions
 	ln --force --symbolic --verbose ${PWD}/debcraft.sh ~/.local/bin/debcraft
 	ln --force --symbolic --verbose ${PWD}/bash-completion/debcraft-completion.sh ~/.local/share/bash-completion/completions/debcraft

=== debian/changelog ===
debcraft (0.5.0) unstable; urgency=medium

  [ TheJayMann ]
  * Use git rev-parse to retrieve commit id
  * Implement cross-builds with e.g.
    'debcraft build --host-architecture=arm64'

  [ Otto Kekäläinen ]
  * Apply patches with Quilt when dpkg-source is skipped
  * Clean up *after* the build if run with `--clean`
  * Allow distribution selection to have `-backports` suffix
  * Add 'questing' as the new default Ubuntu development release

 -- Otto Kekäläinen <otto@debian.org>  Sat, 03 May 2025 18:16:25 -0700

## debcraft 0.6.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #!/usr/bin/make -f
-# SPDX-FileCopyrightText: 2024 Otto Kekäläinen <otto@debian.org>
+# SPDX-FileCopyrightText: 2023-2025 Otto Kekäläinen <otto@debian.org>
 #
 # SPDX-License-Identifier: GPL-3.0-or-later
 
@@ -12,10 +12,13 @@
 
 build-depends:
 	@echo "Check all build dependencies are present"
+	@help2man --version | head -n 1
+
+test-depends:
+	@echo "Check all test dependencies are present"
 	@echo -n "Codespell version: "
 	@codespell --version
 	@echo $$(shellcheck --version | head -n 2)
-	@help2man --version | head -n 1
 
 build: manpage build-depends
 
@@ -58,7 +61,7 @@
 # All generic static tests that don't need Debcraft to actually run
 # @TODO: Evaluate using '-o all' to run extra validation (https://github.com/koalaman/shellcheck/wiki/Optional)
 # @TODO: podman build --validate Containerfile?
-test-static:
+test-static: test-depends
 	@echo "Running static tests"
 	codespell --interactive=0 --check-filenames --check-hidden --skip=.git
 	shellcheck -x --shell=bash $(shell grep -Irnw -e '^#!.*/bash' | sort -u |cut -d ':' -f 1 | xargs)

=== debian/changelog ===
debcraft (0.6.0) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * Rename `debcraft validate` to `debcraft improve` and extend features
    (Closes: #1111477)
  * Support enabling local repo with DEBCRAFT_EXTRA_REPOSITORY
  * If package has no autopkgtests, use autodep8 to run some
  * Fall back to commit id when building a detached HEAD
  * Make upstream tarball (if exists) available for builds
  * Improve notification about cleaning and resetting git repository
  * Add Debian to Ubuntu release mapping: Trixie is like Plucky
  * Strip debug symbols from GCC to keep container image size reasonable
  * Update copyright years and format debian/copyright properly
  * Separate test depends from build depends (Closes: #1116727)
  * Pin Debian experimental to enable packages getting installed from there
  * Add support for sccache and Rust builds caching
  * Replace `dpkg-parsechangelog` with plain shell commands
  * Store all build artefacts in ~/.cache/debcraft
  * When checking for release tags, only consider name space debian|ubuntu/*
  * Strip `-proposed-updates` from container name, similar to `-security`
  * On every build run './debian/rules clean' to ensure sources are clean
  * Run `apt-get update` in background so dropping to `debcraft shell` is faster

  [ TheJayMann ]
  * Ignore quilt exit code 2

  [ Dominik Stadler ]
  * Add section about using debcraft in GitHub Actions

  [ Nicola Chiapolini ]
  * Explicitly use `Containerfile` to fix container builds with Docker

  [ Aquila Macedo ]
  * Implement proper CI with Docker-in-Docker setup for Debcraft development,
    but temporarily skip failing tests in GitLab CI until everything has been
    made fully compatible with DinD CI runs

 -- Otto Kekäläinen <otto@debian.org>  Fri, 10 Oct 2025 22:23:45 -0700

=== debian/control ===
--- 
+++ 
@@ -3,15 +3,14 @@
 Priority: optional
 Maintainer: Otto Kekäläinen <otto@debian.org>
 Build-Depends:
+ debhelper-compat (= 13),
  codespell <!nocheck>,
- debhelper-compat (= 13),
  git-buildpackage <!nocheck>,
  help2man,
  podman | docker.io  <!nocheck>,
  shellcheck <!nocheck>,
 Standards-Version: 4.7.0
 Homepage: https://salsa.debian.org/debian/debcraft
-Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/debian/debcraft.git
 Vcs-Browser: https://salsa.debian.org/debian/debcraft

=== debian/rules ===
#!/usr/bin/make -f

override_dh_auto_test:
	@echo "RULES.$@"
	@echo "Skip tests as they require Podman or Docker, which is not supported in most build environments"

%:
	dh $@

=== debian/tests/control ===
Tests:
 smoke,
Depends:
 debcraft,
Restrictions:
 superficial,

## debcraft 0.7.0

=== debian/changelog ===
debcraft (0.7.0) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * Implement `debcraft logs` to list package builds (and releases)
  * Implement first version of `debcraft update`
  * Add Bash completion for update and logs commands
  * Change dput target in `debcraft release` depending on vendor
  * Use existing orig tarball if present in all commands
  * Add debugging function log_debug_env() to list all variables
  * Add 'resolute' as the new default Ubuntu development release

  [ Dominik Stadler ]
  * Add initial support for Debian Forky

 -- Otto Kekäläinen <otto@debian.org>  Sat, 22 Nov 2025 10:36:37 -0800

=== debian/control ===
--- 
+++ 
@@ -18,6 +18,7 @@
 Architecture: all
 Depends:
  podman | docker.io,
+ sensible-utils,
  ${misc:Depends},
 Description: Easy, fast and secure way to build Debian packages
  Debcraft is a tool to build Debian packages as easily as possible. It uses

## debcraft 0.8.0

=== debian/changelog ===
debcraft (0.8.0) unstable; urgency=medium

  * Replace deprecated `cp` option `no-clobber` with equivalent `update=none`
  * Switch diffoscope to only compare using the .changes plugin
  * Use clickable_link() to print OSC 8 hyperlinks in shell
  * Show links without scheme so output is shorter and cleaner
  * Fix test suite to handle OSC8 hyperlink sequences in output
  * Disable lintian-brush as it was removed from Debian testing
  * Point the stars in the logo up

 -- Otto Kekäläinen <otto@debian.org>  Sun, 04 Jan 2026 08:08:08 +0000

## debcraft 0.8.1

=== Makefile ===
--- 
+++ 
@@ -50,7 +50,7 @@
 	cp -a src $(DESTDIR)/usr/share/debcraft
 
 install-local:
-	@echo "Installing Debcraft as symlinc at ~/bin/debcraft"
+	@echo "Installing Debcraft as symlink at ~/bin/debcraft"
 	mkdir -p ~/.local/bin
 	mkdir -p ~/.local/share/bash-completion/completions
 	ln --force --symbolic --verbose ${PWD}/debcraft.sh ~/.local/bin/debcraft

=== debian/changelog ===
debcraft (0.8.1) unstable; urgency=medium

  * Fix various typos and grammar issues
  * When building for Ubuntu, use the *-proposed pocket by default
  * Build Ubuntu 26.04 binaries as amd64v3 by default
  * Refactor DEBIAN_VERSION and PACKAGE_VERSION into shared location
  * Improve version parsing in commit message amendment
  * Use -B flag when creating import branch in instructions
  * Add interactive safeguard for patch rebase failures
  * Implement log_command() to show users what commands are run
  * Store git commit id in source exports
  * Update Debian copyright for 2026
  * Drop redundant `Priority: optional`
  * Bump Debian Policy version
  * Surround K in `[k]ept` for clarity on what K means in the prompt when
    running `debcraft update`

 -- Otto Kekäläinen <otto@debian.org>  Tue, 20 Jan 2026 07:14:34 +0000

=== debian/control ===
Source: debcraft
Section: misc
Maintainer: Otto Kekäläinen <otto@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 codespell <!nocheck>,
 git-buildpackage <!nocheck>,
 help2man,
 podman | docker.io <!nocheck>,
 shellcheck <!nocheck>,
Standards-Version: 4.7.3
Homepage: https://salsa.debian.org/debian/debcraft
Vcs-Git: https://salsa.debian.org/debian/debcraft.git
Vcs-Browser: https://salsa.debian.org/debian/debcraft

Package: debcraft
Architecture: all
Depends:
 podman | docker.io,
 sensible-utils,
 ${misc:Depends},
Description: Easy, fast and secure way to build Debian packages
 Debcraft is a tool to build Debian packages as easily as possible. It uses
 Podman/Docker to automatically create a hermetic network-less build container
 based on the distribution defined in the source package debian/changelog with
 the dependencies defined in debian/control. Users don't need to manually create
 nor update root filesystems. If there is no source package, Debcraft will
 automatically download it.
 .
 Thanks to efficient caching, rebuilds are blazing fast, and additional logs make
 it easy to see what changed in the end result between each build.
 .
 The tool is fully written in Bash, so reasoning about how it works is easy. It
 does not need to run on Debian as all builds happen inside containers.
